#include "test-skill.h"

#include <adventure-pack/ap-skill.h>

#include <glib.h>

void
skill_fixture_set_up (SkillFixture  *fixture,
                      gconstpointer  user_data)
{
    fixture->skill = ap_skill_new ();
}

void
skill_fixture_tear_down (SkillFixture  *fixture,
                         gconstpointer  user_data)
{
    g_clear_object (&fixture->skill);
}

void
test_skill_name (SkillFixture  *fixture,
                 gconstpointer  user_data)
{
    gchar *name;

    ap_skill_set_name (fixture->skill, "Example Skill");

    name = ap_skill_get_name (fixture->skill);

    g_assert_cmpstr (name, ==, "Example Skill");

    g_free (name);
}

void
test_skill_score (SkillFixture  *fixture,
                  gconstpointer  user_data)
{
    gint score;

    ap_skill_set_score (fixture->skill, 4);

    score = ap_skill_get_score (fixture->skill);

    g_assert_cmpint (score, ==, 4);
}

void
test_skill_bonus (SkillFixture  *fixture,
                  gconstpointer  user_data)
{
    gint bonus;

    ap_skill_set_bonus (fixture->skill, 1);

    bonus = ap_skill_get_bonus (fixture->skill);

    g_assert_cmpint (bonus, ==, 1);
}

void
test_skill_modifier (SkillFixture  *fixture,
                     gconstpointer  user_data)
{
    gchar *modifier;

    ap_skill_set_modifier (fixture->skill, "Dexterity");

    modifier = ap_skill_get_modifier (fixture->skill);

    g_assert_cmpstr (modifier, ==, "Dexterity");

    g_free (modifier);
}

void
test_skill_proficient (SkillFixture  *fixture,
                       gconstpointer  user_data)
{
    gboolean proficient;

    ap_skill_set_proficient (fixture->skill, TRUE);

    proficient = ap_skill_get_proficient (fixture->skill);

    g_assert (proficient == TRUE);
}
